#include <LiquidCrystal.h>
#include <OneWire.h>
byte _d18x2x1Addr[8]={0x28, 0xFF, 0x3B, 0x8B, 0x72, 0x15, 0x3, 0xA0};

LiquidCrystal _lcd1(12, 11, 5, 4, 3, 2);
int _dispTempLength1=0;
boolean _isNeedClearDisp1;

OneWire  _ow7(7);
int _gtv1;
bool _gtv2;
int _gtv3;
int _disp1oldLength = 0;
int _disp2oldLength = 0;
unsigned long _d18x2x1Tti = 0UL;
float _d18x2x1O = 0.00;
bool _gen1I = 0;
bool _gen1O = 0;
unsigned long _gen1P = 0UL;
bool _count1I = 0;
int _count1P = 0;
bool _bounse1S = 0;
bool _bounse1O = 0;
unsigned long _bounse1P = 0UL;
bool _trgr1 = 0;
bool _bounseInputD8S = 0;
bool _bounseInputD8O = 0;
unsigned long _bounseInputD8P = 0UL;
bool _bounseInputD10S = 0;
bool _bounseInputD10O = 0;
unsigned long _bounseInputD10P = 0UL;
void setup()
{
pinMode(10, INPUT);
digitalWrite(10, HIGH);
pinMode(8, INPUT);
digitalWrite(8, HIGH);
pinMode(13, OUTPUT);

_lcd1.begin(16, 2);
_bounseInputD8O =  digitalRead(8);
_bounseInputD10O =  digitalRead(10);
}
void loop()
{if (_isNeedClearDisp1) {_lcd1.clear(); _isNeedClearDisp1= 0;}

bool  _bounceInputTmpD8 =  (digitalRead (8));

if (_bounseInputD8S) 
    {
     if (millis() >= (_bounseInputD8P + 40)) 
         {_bounseInputD8O= _bounceInputTmpD8; _bounseInputD8S=0;}
     }
else
    {
     if (_bounceInputTmpD8 != _bounseInputD8O )
         {_bounseInputD8S=1; _bounseInputD8P = millis();} 
      } 
bool  _bounceInputTmpD10 =  (digitalRead (10));

if (_bounseInputD10S) 
    {
     if (millis() >= (_bounseInputD10P + 40)) 
         {_bounseInputD10O= _bounceInputTmpD10; _bounseInputD10S=0;}
     }
else
    {
     if (_bounceInputTmpD10 != _bounseInputD10O )
         {_bounseInputD10S=1; _bounseInputD10P = millis();} 
      } 



if(_isTimer(_d18x2x1Tti, 1000)) {
_d18x2x1Tti = millis(); 
_d18x2x1O=  _readDS18_ow7(_d18x2x1Addr, 0);}
_gtv1 = ((int((( (analogRead (5)))*(0.0049))/(0.0173))))+((int((_d18x2x1O))));
if (1) {
_dispTempLength1 = ((((( _floatToStringWitRaz(( (analogRead (5)))*(0.0049),2))) + (String(" V")) + (String("  T ")) + (( _floatToStringWitRaz((_d18x2x1O),2)))))).length();
if (_disp2oldLength > _dispTempLength1) {_isNeedClearDisp1 = 1;} 
_disp2oldLength = _dispTempLength1;
_lcd1.setCursor(0, 0);
_lcd1.print((((( _floatToStringWitRaz(( (analogRead (5)))*(0.0049),2))) + (String(" V")) + (String("  T ")) + (( _floatToStringWitRaz((_d18x2x1O),2))))));
} else {
if (_disp2oldLength > 0) {_isNeedClearDisp1 = 1; _disp2oldLength = 0;} 
}
if (1) {
_dispTempLength1 = ((((String("T ")) + ((String(((int((( (analogRead (5)))*(0.0049))/(0.0173))))+((int((_d18x2x1O))))))) + (String(" -")) + (String(" Ust")) + ((String(_gtv3)))))).length();
if (_disp1oldLength > _dispTempLength1) {_isNeedClearDisp1 = 1;} 
_disp1oldLength = _dispTempLength1;
_lcd1.setCursor(0, 1);
_lcd1.print((((String("T ")) + ((String(((int((( (analogRead (5)))*(0.0049))/(0.0173))))+((int((_d18x2x1O))))))) + (String(" -")) + (String(" Ust")) + ((String(_gtv3))))));
} else {
if (_disp1oldLength > 0) {_isNeedClearDisp1 = 1; _disp1oldLength = 0;} 
}
if (( (( (!(_bounseInputD8O)) && (!((_gtv3) <= (0))) )) || (( (!(_bounseInputD10O)) && (!(_gtv2)) )) )) { if (! _gen1I) { _gen1I = 1; _gen1O = 1; _gen1P = millis(); } } else { _gen1I = 0 ; _gen1O= 0;}
 if (_gen1I) {  if ( _isTimer ( _gen1P , 50 )) { _gen1P = millis(); _gen1O = ! _gen1O;}}

if (_gen1O) 
   { 
   if (! _count1I)  
      {
        if (( (!(_bounseInputD10O)) && (!(_gtv2)) )) {_count1P = _count1P+1;} else {_count1P = _count1P-1;};
       _count1I = 1;
      }
   }
else
   {
   _count1I=0;
   }
bool   _bounceTmpD1 = (_gtv1) >= (_count1P);

if (_bounse1S) 
    {
     if (millis() >= (_bounse1P + 40)) 
         {_bounse1O=  _bounceTmpD1; _bounse1S=0;}
     }
else
    {
     if ( _bounceTmpD1 != _bounse1O )
         {_bounse1S=1; _bounse1P = millis();} 
      } 
if((_gtv1) <= ((_gtv3)-(2))) _trgr1 = 0;
if(_bounse1O) _trgr1 = 1;
_gtv3 = _count1P;
_gtv2 =  _count1P  >=  500;
digitalWrite(13, _trgr1);




}
bool _isTimer(unsigned long startTime, unsigned long period )
  {
  unsigned long currentTime;
currentTime = millis();
if (currentTime>= startTime) {return (currentTime>=(startTime + period));} else {return (currentTime >=(4294967295-startTime+period));}
  }
String  _floatToStringWitRaz(float value, int raz)
{
  float tv;
  int ti = int(value);
  String ts = String(ti);
  if (raz == 0) {
    return ts;
  }
  ts += ".";
  float tf = abs(value - ti);
  for (int i = 1; i <= raz; i++ )
  {
    tv = tf * 10;
    ti = int(tv);
    ts += String(ti);
    tf = (tv - ti);
  }
  return ts;
}
float _convertDS18x2xData(byte type_s, byte data[12])
{
  int16_t raw = (data[1] << 8) | data[0];
  if (type_s) 
  {
  raw = raw << 3; 
  if (data[7] == 0x10) { raw = (raw & 0xFFF0) + 12 - data[6]; }
  }
else 
  {
   byte cfg = (data[4] & 0x60);
   if (cfg == 0x00) raw = raw & ~7;   else if (cfg == 0x20) raw = raw & ~3;  else if (cfg == 0x40) raw = raw & ~1;
  }
return  (float)raw / 16.0;
}
float _readDS18_ow7(byte addr[8], byte type_s)
{  byte data[12];
byte i;
_ow7.reset();
_ow7.select(addr);
_ow7.write(0xBE);
for ( i = 0; i < 9; i++) {
 data[i] = _ow7.read();}
_ow7.reset();
_ow7.select(addr);
_ow7.write(0x44, 1);
return _convertDS18x2xData(type_s, data);}
